---
title: PushMessageData
slug: Web/API/PushMessageData
tags:
  - API
  - Experimental
  - Interface
  - Push
  - Push API
  - PushMessageData
  - Reference
  - Service Workers
---
<p>{{APIRef("Push API")}}{{SeeCompatTable()}}</p>

<p>The <code><strong>PushMessageData</strong></code> interface of the <a href="/en-US/docs/Web/API/Push_API">Push API</a> provides methods which let you retrieve the push data sent by a server in various formats.</p>

<p>Unlike the similar methods in the <a href="/en-US/docs/Web/API/Fetch_API">Fetch API</a>, which only allow the method to be invoked once, these methods can be called multiple times.</p>

<p>Messages received through the Push API are sent encrypted by push services and then automatically decrypted by browsers before they are made accessible through the methods of the <code>PushMessageData</code> interface.</p>

<h2 id="Properties">Properties</h2>

<p>None.</p>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("PushMessageData.arrayBuffer()")}}</dt>
 <dd>Extracts the data as an {{domxref("ArrayBuffer")}} object.</dd>
 <dt>{{domxref("PushMessageData.blob()")}}</dt>
 <dd>Extracts the data as a {{domxref("Blob")}} object.</dd>
 <dt>{{domxref("PushMessageData.json()")}}</dt>
 <dd>Extracts the data as a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/JSON">JSON</a> object.</dd>
 <dt>{{domxref("PushMessageData.text()")}}</dt>
 <dd>Extracts the data as a plain text string.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">self.addEventListener('push', function(event) {
  var obj = event.data.json();

  if(obj.action === 'subscribe' || obj.action === 'unsubscribe') {
    fireNotification(obj, event);
    port.postMessage(obj);
  } else if(obj.action === 'init' || obj.action === 'chatMsg') {
    port.postMessage(obj);
  }
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Push API', '#pushmessagedata-interface', 'PushMessageData')}}</td>
   <td>{{Spec2('Push API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.PushMessageData")}}</p>
</div>
